/*
 * Copyright (C) 2019  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ABOUT_REPLY_HH_1D3B5D2F95E635E631A0014D7CFD7A57//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define ABOUT_REPLY_HH_1D3B5D2F95E635E631A0014D7CFD7A57

#include "src/util/printable.hh"

#include <boost/optional.hpp>

#include <string>

namespace Fred {
namespace Registry {
namespace Diagnostics {

struct AboutReply
{
    struct Version : Util::Printable<Version>
    {
        static Version from_string(const std::string& full);//{MAJOR}.{MINOR}.{PATCH}[-rc{RC}][-{DISTANCE}-g{COMMIT}]
        std::string full;
        unsigned major;
        unsigned minor;
        unsigned patch;
        boost::optional<unsigned> rc;
        struct Commit : Util::Printable<Commit>
        {
            unsigned distance;
            std::string hash;
            std::string to_string()const;
        };
        boost::optional<Commit> commit;
        std::string to_string()const;
    };
    struct Data : Util::Printable<Data>
    {
        Version api_version;
        Version server_version;
        std::string to_string()const;
    };
    Data data;
};

}//namespace Fred::Registry::Diagnostics
}//namespace Fred::Registry
}//namespace Fred

#endif//ABOUT_REPLY_HH_1D3B5D2F95E635E631A0014D7CFD7A57
