/*
 * Copyright (C) 2019  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/diagnostics/ping.hh"

#include "libfred/opcontext.hh"

namespace Fred {
namespace Registry {
namespace Diagnostics {

PingReply::Data ping(const PingRequest& request)
{
    PingReply::Data reply;
    if (request.check_database_accessibility)
    {
        try
        {
            LibFred::OperationContextCreator ctx;
            ctx.get_conn().exec("SELECT 'ping'::TEXT WHERE false");
            reply.database_is_accessible = true;
        }
        catch (...)
        {
            reply.database_is_accessible = false;
        }
    }
    return reply;
}

}//namespace Fred::Registry::Diagnostics
}//namespace Fred::Registry
}//namespace Fred
