/*
 * Copyright (C) 2019  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef PING_REPLY_HH_D1E364D692F7BC197C3E9B9F83C91202//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define PING_REPLY_HH_D1E364D692F7BC197C3E9B9F83C91202

#include "src/util/printable.hh"

#include <boost/optional.hpp>

namespace Fred {
namespace Registry {
namespace Diagnostics {

struct PingReply
{
    struct Data : Util::Printable<Data>
    {
        boost::optional<bool> database_is_accessible;//missing value means no database accessibility was checked
        std::string to_string()const;
    };
    Data data;
};

}//namespace Fred::Registry::Diagnostics
}//namespace Fred::Registry
}//namespace Fred

#endif//PING_REPLY_HH_D1E364D692F7BC197C3E9B9F83C91202
