/*
 * Copyright (C) 2018  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef REGISTRAR_COMMON_TYPES_HH_83A2B9C2A941EBD79135DB16CE0D9310//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define REGISTRAR_COMMON_TYPES_HH_83A2B9C2A941EBD79135DB16CE0D9310

#include "src/util/strong_type.hh"
#include "src/exceptions.hh"

#include <string>

namespace Fred {
namespace Registry {
namespace Registrar {

struct Exception : Registry::Exception
{
    explicit Exception(const std::string& msg);
};

struct InternalServerError : Exception
{
    explicit InternalServerError(const std::string& msg);
};

using RegistrarHandle = Util::StrongString<struct RegistrarHandle_Tag, Util::Skill::Printable>;
using PhoneNumber = Util::StrongString<struct PhoneNumber_Tag, Util::Skill::Printable>;
using EmailAddress = Util::StrongString<struct EmailAddress_Tag, Util::Skill::Printable>;
using Url = Util::StrongString<struct Url_Tag, Util::Skill::Printable>;
using PostalCode = Util::StrongString<struct PostalCode_Tag, Util::Skill::Printable>;
using CountryCode = Util::StrongString<struct CountryCode_Tag, Util::Skill::Printable>;
using VatIdentificationNumber = Util::StrongString<struct VatIdentificationNumber_Tag, Util::Skill::Printable>;
using CompanyRegistrationNumber = Util::StrongString<struct CompanyRegistrationNumber_Tag, Util::Skill::Printable>;
using Credit = Util::StrongString<struct Credit_Tag, Util::Skill::Printable>;

struct PlaceAddress : Util::Printable<PlaceAddress>
{
    std::vector<std::string> street;
    std::string city;
    std::string state_or_province;
    PostalCode postal_code;
    CountryCode country_code;
    std::string to_string()const;
};

struct ZoneAccess : Util::Printable<ZoneAccess>
{
    bool has_access_now;
    std::string to_string()const;
};

}//namespace Fred::Registry::Registrar
}//namespace Fred::Registry
}//namespace Fred

#endif//REGISTRAR_COMMON_TYPES_HH_83A2B9C2A941EBD79135DB16CE0D9310
